<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- XMLPublish framework
This file is specific to a document class (not in XMLPublish core)
This file is an XSLT library, designed to be imported.

The files, after splitting from specific XML markup into 1 file per item
are named here, into another directory $directory.

This XSLT file serves to centralize header and files names generation.
One should implement the templates ...

The present implementation is adapted to the source file
http://wwbota.free.fr\XSLT_models\README.htm  

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/

-->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0" >

<xsl:param name='directory' select='"work/items"'/>
<xsl:param name='items-directory' select='"items"'/>
<xsl:param name='SITE' select='"html/"'/>

<!-- This is called in the item context to get the human-readable name of the item -->
<xsl:template name="item_name" >
 <xsl:value-of select="Document" />
</xsl:template>

<!-- This is called in the item context to get a computer name of the item, suitable for making file and URL name -->
<xsl:template name="item_key" >
 <xsl:value-of select="Reference" />
</xsl:template>

<!-- Called in the context of 1srt level elements of thesaurus.xml -->
<!-- a name for computers (file name, etc) -->
<xsl:template name="rubric-name" >
  <xsl:value-of select="@name" />
</xsl:template>
<!-- a name for humans (display, etc) -->
<xsl:template name="rubric-label" >
  <xsl:value-of select="@label" />
</xsl:template>
<!--============================================-->
<xsl:template name="item_file_name_relative" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat(  $item_key, '.xml')" />
</xsl:template>

<xsl:template name="item_file_name" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $directory, '/', $item_key, '.xml')" />
</xsl:template>

<xsl:template name="item_file_name_html" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $items-directory, '/', $item_key, '.html')" />
</xsl:template>

<xsl:template name="item_file_name_html_abs" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $SITE, $items-directory, '/',  $item_key, '.html' )" />
</xsl:template>

</xsl:stylesheet> 
