<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- XMLPublish framework
This file is specific to a document class (not in XMLPublish core)
This file is an XSLT library, designed to be imported.

The files, after splitting from specific XML markup into 1 file per item
are named here, into another directory $directory.

This XSLT file serves to centralize header and files names generation.
One should implement the 3 templates item_name, item_file_name, item_file_name_html.

The present implementation is adapted to the source file
http://wwbota.free.fr\XSLT_models\README.htm  

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/

-->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0" >

<xsl:param name='directory' select='"work/items"'/>
<xsl:param name='items-directory' select='"items"'/>

<xsl:template name="item_file_name" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $directory, '/', $item_key, '.xml')" />
</xsl:template>
<xsl:template name="item_file_name_html" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $items-directory, '/', $item_key, '.html')" />
</xsl:template>
<xsl:template name="item_name" >
 <xsl:value-of select="substring-before(*[local-name()='h1'][1],' ')" />&#160;
 <xsl:value-of select="substring-before( substring-after(*[local-name()='h1'][1],' '),' ')" />
</xsl:template>
<xsl:template name="item_key" >
 <xsl:value-of select="substring-before(*[local-name()='h1'][1],' ')" />
 <xsl:value-of select="concat('-',generate-id())" />
</xsl:template>

<xsl:template name="rubric_name"><!-- ?????????????? -->
 <xsl:value-of select="substring-before(*[local-name()='h2'][1],' ')" />
</xsl:template>

  <!-- a name for computers (file name, etc) -->
<xsl:template name="rubric-name" >
  <xsl:message> DEBUG item_file_name.xslt xsl:template name="rubric-name" <xsl:value-of select="@name" /> </xsl:message>
  <xsl:value-of select="@name" />
</xsl:template>
  <!-- a name for humans (display, etc) -->
<xsl:template name="rubric-label" >
  <xsl:value-of select="@label" />
</xsl:template> 
</xsl:stylesheet> 
