<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
Appends after last first-level element of document at URL $main all first-level elements of input document .

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /home/jmv/cvsroot/XMLPublication/kernel/append2.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0" >

<xsl:param name='main'/>
<xsl:param name='result'/>
<xsl:param name='input-files'/>

<xsl:variable name='main_doc' select="document($main, /)" />
<xsl:variable name='append' select="/" />

<xsl:template match="/" >
 <xsl:variable name='beginning' ><xsl:copy-of select="$main_doc" /></xsl:variable>
 <xsl:message>[XMLPub] Copying <xsl:copy-of select="count($beginning/*/*)" /> elements
  from resource <xsl:copy-of select="$main" /> ...</xsl:message>
 <xsl:message>[XMLPub] input-files <xsl:copy-of select="$input-files" /></xsl:message>
 <xsl:message>[XMLPub] Creating document <xsl:copy-of select="$result" /> ...</xsl:message>
 <xsl:document href='{$result}' >
 <xsl:for-each select="$beginning/*">
  <xsl:copy>
   <!-- select all first level tags of both documents : -->
   <xsl:copy-of select="$beginning/*/*" />
   <xsl:message>[XMLPub] Appending <xsl:copy-of select="count($append/*/*)" /> elements ...</xsl:message>
   <xsl:copy-of select="$append/*/*" />
  </xsl:copy>
 </xsl:for-each>
 </xsl:document>
</xsl:template>

</xsl:stylesheet>
