# Copyright J.M. Vanel 2001 - under GNU public licence
# jmvanel@free.fr

# Worldwide Botanical Knowledge Base
# http://wwbota.free.fr/

use strict;
if(!(defined $ARGV[0])) {
    print<<EOF;
Usage: $0 Excel_File HTML_File
EOF
    exit;
}
use Spreadsheet::ParseExcel;
my $oExcel = new Spreadsheet::ParseExcel;
my $oBook = $oExcel->Parse($ARGV[0]);

open ( HTML, ">$ARGV[1]" ) || die "Ouverture fichier HTML en sortie rate: $!";

my($iR, $iC, $oWkS, $oWkC);
print ( HTML "<html>\n" );
print ( HTML "<!-- ========================================= -->\n" );
print ( HTML "<!-- FILE  :", $oBook->{File} , " -->\n" );
print ( HTML "<!-- Sheet Count :", $oBook->{SheetCount} , " -->\n" );
print ( HTML "<!-- AUTHOR:", $oBook->{Author} , " -->\n" );
for(my $iSheet=0; $iSheet < $oBook->{SheetCount} ; $iSheet++) {
    $oWkS = $oBook->{Worksheet}[$iSheet];
    print ( HTML "<!-- ========= SHEET:", $oWkS->{Name}, " -->\n" );
    print ( HTML "<table>\n" );
    for(my $iR = $oWkS->{MinRow} ; 
            defined $oWkS->{MaxRow} && $iR <= $oWkS->{MaxRow} ; $iR++) {
        print ( HTML "<tr><!-- L. ", $iR, " -->" );
        for(my $iC = $oWkS->{MinCol} ;
                        defined $oWkS->{MaxCol} && $iC <= $oWkS->{MaxCol} ; $iC++) {
            $oWkC = $oWkS->{Cells}[$iR][$iC];
            print ( HTML "<td>" );
            # print ( HTML "( $iR , $iC ) =>", $oWkC->Value, "\n" ) if($oWkC);
            print ( HTML $oWkC->Value ) if($oWkC);
            print ( HTML "</td>" );
        }
        print ( HTML "</tr>\n" );
    }
    print ( HTML "</table>\n" );
}
print ( HTML "</html>\n" );
