<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
Purpose: filter a words list:
- with a stop-words list
- words begining with a numeral
- words identical to a stopword when ignoring case

This is an XSLT library, designed to be imported.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /home/jmv/cvsroot/XMLPublication/kernel/filter-words-list.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.1"
 	xmlns:doc="http://xsltsl.org/xsl/documentation/1.0"
	xmlns:str="http://xsltsl.org/string"
	extension-element-prefixes="doc str"
        xmlns:saxon="http://icl.com/saxon"
>

  <xsl:import href="normalize-word.xslt" />

  <xsl:param name="stop-words-URL" select="'stop-words.xml'" />
  <xsl:variable name="stop-words" select="document($stop-words-URL)" />

<!-- 
Purpose: see header
Parameters:
Input: nodes:
Output: a node list containing <w> or <saxon:token> elements . 
-->
  <xsl:template name="filter-words-list">
    <xsl:param name="nodes" />
    <!--  Fatal Error! To use a result tree fragment in a path expression, either use exslt:node-set() or specify version='1.1'
     need to put version='1.1' in importing stylesheet !!!!
-->
<xsl:message>DEBUG filter <xsl:value-of select="count($nodes/*)" /> words:</xsl:message>
    <!-- <xsl:message>DEBUG filter: words: <xsl:value-of select="$nodes" /> </xsl:message> -->
    <xsl:for-each select="$nodes//w | $nodes//saxon:token " >
      <xsl:variable name="normalized-form" >
        <xsl:apply-templates select='.' mode='normalize-word' />
      </xsl:variable>
      <!-- <xsl:message>DEBUG $normalized-form= <xsl:copy-of select="$normalized-form" /></xsl:message> -->
      <xsl:variable name="first-char" select="substring ( ., 1,1)" />
      <xsl:choose>
        <xsl:when test="($stop-words//w | $nodes//saxon:token )= $normalized-form" >
          <xsl:copy>
            <xsl:attribute name ="is-stop-word" />
            <xsl:value-of select="." />
          </xsl:copy>
        </xsl:when>
        <xsl:when  test=" not(.)
          or $first-char='0'
          or $first-char='1'
          or $first-char='2'
          or $first-char='3'
          or $first-char='4'
          or $first-char='5'
          or $first-char='6'
          or $first-char='7'
          or $first-char='8'
          or $first-char='9' ">
          <!-- suppress -->
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="." />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
