<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
Purpose: filter a words list:
- with a stop-words list
- words begining with a numeral

This is an XSLT library, designed to be imported.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /usr/local/cvsroot/XMLPublication/kernel/filter-words-list.xslt,v 1.1 2001/11/09 21:37:37 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0"
 	xmlns:doc="http://xsltsl.org/xsl/documentation/1.0"
	xmlns:str="http://xsltsl.org/string"
	extension-element-prefixes="doc str">

  <xsl:param name="stop-words-URL" select="'stop-words.xml'" />
  <xsl:variable name="stop-words" select="document($stop-words-URL)" />

<!-- 
Purpose: see header
Parameters:
Input: nodes:
Output: a node list containing <w> elements . 
xslsl: conformance: $string doit s'appeler $text
-->
  <xsl:template name="filter-words-list">
    <xsl:param name="nodes" />
    <xsl:for-each select="$nodes//w" >
      <xsl:variable name="first-char" select="substring ( ., 1,1)" />
      <xsl:choose>
        <xsl:when test="$stop-words//w = ." >
          <xsl:copy>
            <xsl:attribute name ="is-stop-word" />
            <xsl:value-of select="." />
          </xsl:copy>
        </xsl:when>
        <xsl:when  test=" not(.)
          or $first-char='0'
          or $first-char='1'
          or $first-char='2'
          or $first-char='3'
          or $first-char='4'
          or $first-char='5'
          or $first-char='6'
          or $first-char='7'
          or $first-char='8'
          or $first-char='9' ">
        </xsl:when><!-- suppress -->
        <xsl:otherwise>
          <xsl:copy-of select="." />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
