<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- XMLPublication framework
Creates HTML from specific XML markup.
Header generation is delegated to the template item_name which can be redefined in importing transform.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /home/jmv/cvsroot/XMLPublication/kernel/format-HTML-impl.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0" >

<xsl:import href="item_file_name-generic.xslt" />
<xsl:import href="wrapper.xslt" />

<!-- <xsl:output encoding="iso-8859-1" omit-xml-declaration="yes" /> -->
<xsl:output encoding="utf-8" omit-xml-declaration="yes" />

<xsl:param name='book-title-URL' select="'book-title.html'" />

<xsl:param name='SETTINGS_URI' select="'..'" />
<xsl:variable name='SETTINGS_URI2' >
   <xsl:value-of select="$SETTINGS_URI" />
</xsl:variable>

<xsl:template match="/">
 <xsl:call-template name='format-HTML'>
  <xsl:with-param name='item-document' select="/" />
 </xsl:call-template>
</xsl:template>

<xsl:template name='format-HTML' >
 <xsl:param name='item-document' select="/" />
 <xsl:variable name='book-title-URL_doc' select="document($book-title-URL, $SETTINGS_URI2)" />
 <xsl:variable name='content' >
  <book>
   <xsl:copy-of select="$book-title-URL_doc" />
   <br clear="left"/>
   <!-- <xsl:apply-templates select="$item-document/*" mode='item' /> -->
   <xsl:apply-templates select="$item-document/*" mode="recursive" />
  </book>
 </xsl:variable>
 <xsl:call-template name="wrapper">
  <xsl:with-param name='content' select='$content' />
 </xsl:call-template>
</xsl:template>

<xsl:template match="*" mode='item' >
 <xsl:choose>
  <xsl:when test='not(namespace-uri()="http://www.w3.org/1999/xhtml")'>
   <xsl:message>[XMLPub] Making XHTML for "<xsl:call-template name="item_name" />" ...</xsl:message>
   <div class="item">
     <xsl:choose>
       <xsl:when test='not(h1)'>
         <h1 class="item_header">
           <xsl:call-template name="item_name" />
         </h1>
       </xsl:when>
     </xsl:choose>

    <xsl:for-each select= "*" >
     <xsl:apply-templates select="." mode="rubric" />
    </xsl:for-each>
   </div>
  </xsl:when>
  <xsl:otherwise>
   <xsl:message>Copying XHTML for <xsl:call-template name="item_name" /> ...</xsl:message>
   <xsl:copy-of select="." />
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template match="*" mode="rubric" >
<!-- TODO ?? : <xsl:call-template name="rubric_name" /> --> 
  <xsl:if test="string(.)"><!-- No rubric header alone if rubric empty --> 
    <xsl:variable name="rubric_name" select="translate(local-name(), '_', ' ')" />
<!--
    <div class="rubric">
      <div class="{$rubric_name}">
        <h2 class="rubric_header">
          <xsl:choose>
            <xsl:when test='h2'>
            </xsl:when>
            <xsl:otherwise>
              <xsl:copy-of select="$rubric_name" />
            </xsl:otherwise>
          </xsl:choose>
        </h2>
        <xsl:apply-templates select="." mode="recursive" />
      </div>
    </div>
-->
    <div class="rubric">
      <div class="{$rubric_name}">
        <xsl:apply-templates select="." mode="recursive" />
      </div>
    </div>
  </xsl:if>
</xsl:template>

<xsl:template match="@*|*|processing-instruction()|comment()" mode="recursive" >
 <xsl:copy>
  <xsl:apply-templates select="*|@*|text()|processing-instruction()|comment()" mode="recursive" /> 
  </xsl:copy>
</xsl:template>

<xsl:template match="_xmlpub:source" xmlns:_xmlpub="http://xmlpublication.org/" mode="recursive" >
  <p class="xmlpub-source">
    <xsl:variable name='sources' select="substring-before(., '.')" />
    from: <a href="{concat('../sources.html#', $sources)}">
    <xsl:value-of select="$sources" /></a>
  </p>
</xsl:template>
</xsl:stylesheet> 
