<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- XMLPublish framework
This file is an XSLT library, designed to be imported.

The files, after splitting from specific XML markup into 1 file per item
are named here, into another directory $directory.

This XSLT file serves to centralize header and files names generation.
One should implement the 3 templates item_name, item_file_name, item_file_name_html.

The present implementation is generic and should work with any source document, although the item_name, which will be displayed in the HTML pages is not satisfying. But the XMLPublish framework cannot guess how to generate a human-readable name from an element content!

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/

-->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0" >

<xsl:param name='directory' select='"xml/items"'/>
<xsl:param name='items-directory' select='"items"'/>
<xsl:param name='SITE' select='"html/"'/>

<!-- This is called in the item context to get the human-readable name of the item -->
<xsl:template name="item_name" >
 <xsl:value-of select="*[1]" />
</xsl:template>

<!-- This is called in the item context to get a computer name of the item, suitable for making file and URL name -->
<xsl:template name="item_key" >
 <xsl:value-of select="concat(name(), '-', generate-id())" />
</xsl:template>

<!--============================================-->
<xsl:template name="item_file_name" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $directory, '/', $item_key, '.xml')" />
</xsl:template>
<xsl:template name="item_file_name_html" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $items-directory, '/', $item_key, '.html')" />
</xsl:template>

<!-- ZZZZZZZZZZZZZ  voir: o est-ce qu'on se sert de ces 2-l ? -->
<xsl:template name="item_file_name_relative" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat(  $item_key, '.xml')" />
</xsl:template>

<!-- used in split-into-items.xslt -->
<xsl:template name="item_file_name_html_abs" >
 <xsl:variable name="item_key" >
  <xsl:call-template name="item_key" />
 </xsl:variable>
 <xsl:value-of select="concat( $SITE, $items-directory, '/',  $item_key, '.html' )" />
</xsl:template>

<!-- Called in the context of 1srt level elements of thesaurus.xml -->
<!-- a name for computers (file name, etc) -->
<xsl:template name="rubric-name" >
  <xsl:message> DEBUG item_file_name.xslt xsl:template name="rubric-name" <xsl:value-of select="@name" /> </xsl:message>
  <xsl:value-of select="@name" />
</xsl:template>
<!-- a name for humans (display, etc) -->
<xsl:template name="rubric-label" >
  <xsl:value-of select="@label" />
</xsl:template>

<!--
<xsl:template name="rubric-name" >
  <xsl:message> DEBUG item_file_name-generic.xslt xsl:template name="rubric-name" </xsl:message>
  <xsl:value-of select="concat (@adj, '_', string(@rubric) )" />
</xsl:template>
<xsl:template name="rubric-label" >
  <xsl:value-of select="concat (@adj, ' ', string(@rubric) )" />
</xsl:template>
-->
</xsl:stylesheet> 

