<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
Appends after last first-level element of input all first-level elements of documents whose URI is in $file-list-file .

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /home/jmv/cvsroot/XMLPublication/kernel/join.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.1" 
xmlns:doc="http://xsltsl.org/xsl/documentation/1.0"
xmlns:str="http://xsltsl.org/string"
xmlns:_xmlpub="http://xmlpublication.org/"
extension-element-prefixes="doc str" >

  <xsl:include href="tokenize-string.xslt" />

   <xsl:param name="file-list-file" />

<xsl:template match="/*" >
  <xsl:variable name='docs' select="document($file-list-file)" />
  <xsl:variable name="file-list">
    <xsl:call-template name="str:tokenize-string">
      <xsl:with-param name="text" select='normalize-space($docs)' />
    </xsl:call-template>
  </xsl:variable>
  <xsl:message>
    xsl:copy-of select="$file-list"
    <xsl:copy-of select="$file-list"  />
  </xsl:message>
  <!-- <xsl:variable name='files' select="document($file-list/*, $docs )" /> -->

  <!-- select all first level tags of all documents : -->
  <xsl:copy>
    <xsl:for-each select="$file-list/*" >
      <xsl:message>Appending document : <xsl:value-of select="." /> ...</xsl:message>
      <xsl:variable name='source' select="document( concat('file:',.), $docs )" />
      <xsl:variable name='source-URI' select="." />
    <xsl:for-each select="$source/*" >
      <xsl:message>xsl:for-each select="$source/*" : name() : <xsl:value-of select="name()" /> ...</xsl:message>
    <!-- loop on items -->
    <xsl:for-each select="*" >
      <xsl:message>xsl:for-each select="*" : name() : <xsl:value-of select="name()" /> ...</xsl:message>
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:attribute name="_xmlpub:source-URI">
          <xsl:value-of select="$source-URI" />
        </xsl:attribute>
        <xsl:copy-of select="*" />
      </xsl:copy>
    </xsl:for-each>
    </xsl:for-each>
      <!-- <xsl:apply-templates mode="add-source-URI" select='$source' >
        <xsl:with-param name="source-URI" >
          <xsl:copy-of select='.' />
        </xsl:with-param>
      </xsl:apply-templates> -->
    </xsl:for-each>
  </xsl:copy>
</xsl:template>

<xsl:template mode="add-source-URI" match='*' >
  <xsl:param name="source-URI" />
      <xsl:message>param : Appending document : <xsl:value-of select="$source-URI" /> ...</xsl:message>
  <xsl:copy>
    <xsl:copy-of select="@*" />
    <xsl:for-each select="*" >
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:attribute name="_xmlpub:source-URI">
          <xsl:value-of select="$source-URI" />
        </xsl:attribute>
        <xsl:copy-of select="*" />
      </xsl:copy>
      <xsl:text>
      </xsl:text>
    </xsl:for-each>
  </xsl:copy>
</xsl:template>
</xsl:stylesheet>
