<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
Makes 1 XHTML index file per rubric.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/

$Header: /home/jmv/cvsroot/XMLPublication/kernel/make-index-by-rubrics-impl.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                xmlns:saxon='http://icl.com/saxon'
                exclude-result-prefixes="saxon"
                version="1.1" >

<xsl:import href="wrapper.xslt" />
<xsl:import href='make-hyperlinked-index.xslt'/>
<xsl:import href='make-words-list.xslt'/>
<xsl:import href='difference-by-value.xslt' />

<xsl:param name='directory'/>
<xsl:param name='thesaurus'/>

<xsl:param name='HTML-wrapper' select='"./presentation.html"'/>
<xsl:param name='book-title-URL' />

<xsl:output encoding="iso-8859-1" />

<xsl:variable name='document' select="/" />
<xsl:variable name='presentation_doc' select="document($HTML-wrapper)" />
<xsl:variable name='book-title-URL_doc' select="document($book-title-URL)" />
<xsl:variable name='thesaurus_doc' select="document($thesaurus)" />
<xsl:variable name="apos" >"</xsl:variable>

  <xsl:template match='rubric' mode='rubric' >
    <xsl:copy-of select="." />
  </xsl:template>

  <xsl:template match='/'>
    <xsl:apply-templates select='/' mode='make-index-by-rubrics' />
  </xsl:template>

<xsl:template match='/' mode='make-index-by-rubrics' >

 <!-- Index by user-defined keywords in rubrics -->
 <!-- ==========================================-->
 <xsl:for-each select="$thesaurus_doc//rubric[@use-keywords = 'yes']">
  <xsl:message> DEBUG xsl:for-each select="$thesaurus_doc//rubric[@use-keywords = 'yes']" </xsl:message>

  <xsl:variable name='rubric'>
   <xsl:apply-templates select='.' mode='rubric' />
  </xsl:variable>

  <xsl:variable name='content' >
   <br clear="left"/>
   <xsl:copy-of select="$book-title-URL_doc" />
   <h1>
    <xsl:attribute name='title'>Index by
     <xsl:value-of select='$rubric//@label' />
    </xsl:attribute>
    <xsl:value-of select='$rubric//@label' />
   </h1>
     <xsl:call-template name="make-hyperlinked-index">
      <xsl:with-param name="source" select="$document" />
      <xsl:with-param name="of" >*</xsl:with-param><!-- TODO: test with $rubric//@item-xpath -->
      <xsl:with-param name="by" select="$rubric//@xpath"/>
      <xsl:with-param name="words" select="keywords" />
      <xsl:with-param name="filter-stop-words" select="@use-stopwords" />
     </xsl:call-template>
  </xsl:variable>
  <xsl:document href="{$directory}/index-{$rubric//@name}.html" omit-xml-declaration="yes" encoding="utf-8">
   <xsl:call-template name="wrapper">
    <xsl:with-param name='content' select='$content' />
   </xsl:call-template>
  </xsl:document>
 </xsl:for-each>

 <!-- Index by content-defined keywords in rubrics : every word appearing in those rubrics are index entries -->
 <!-- =======================================================================================================-->
 <xsl:for-each select="$thesaurus_doc//rubric[@use-keywords != 'yes']">

  <xsl:variable name='rubric'>
   <xsl:apply-templates select='.' mode='rubric' />
  </xsl:variable>

  <xsl:variable name='content' >
   <br clear="left"/>
   <xsl:copy-of select="$book-title-URL_doc" />
   <h1>
    <xsl:attribute name='title'>Table of
     <xsl:value-of select='$rubric//@label' />
    </xsl:attribute>
    <xsl:value-of select='$rubric//@label' />
   </h1>

   <xsl:message> Searching words for rubric "<xsl:value-of select="string( $rubric//@name )" />" ... </xsl:message>
   <xsl:variable name='words-list' >
    <words rubric='{$rubric//@xpath}'>
     <xsl:variable name='rubric-content'  >
      <xsl:apply-templates select="saxon:evaluate(concat('$document//', $rubric//@xpath ) )" mode='add-spaces' />
     </xsl:variable>
     <xsl:call-template name="make-words-list">
      <xsl:with-param name="string" >
       <xsl:apply-templates select="$rubric-content" mode= 'suppress-unwanted-chars' />
      </xsl:with-param>
     </xsl:call-template>
    </words>
   </xsl:variable>

   <xsl:variable name='words-list2' >
    <xsl:choose>
     <xsl:when test= "@use-stopwords != 'no'" >
      <!-- <xsl:variable name= "stop-words" select="$thesaurus_doc//stopwords" /> -->
      <xsl:variable name= "stop-words" select="keywords/w[@is-stop-word]" />
      <xsl:message> DEBUG $stop-words= <xsl:copy-of select="$stop-words"/> </xsl:message>

      <words rubric='{$rubric//@xpath}' use-stopwords="YES">
       <xsl:call-template name='difference-by-value'>
         <xsl:with-param name="v1" select="$words-list/*" />
         <xsl:with-param name="v2" select="$stop-words" />
       </xsl:call-template>
      </words>
      <xsl:message> count($words-list/*/*)= <xsl:value-of select="count($words-list/*/*)" /> </xsl:message>
     </xsl:when>
     <xsl:otherwise>
      <xsl:copy-of select="$words-list" />
     </xsl:otherwise>
    </xsl:choose>
   </xsl:variable>
   <!--
   <xsl:message> count($words-list2/*/*)= <xsl:value-of select="count($words-list2/*/*)" /> </xsl:message>
   <xsl:message> $words-list2= <xsl:copy-of select="$words-list2" /> </xsl:message>
   -->
   <xsl:call-template name="make-hyperlinked-index">
      <xsl:with-param name="source" select="$document" />
      <xsl:with-param name="of" >*</xsl:with-param>
      <xsl:with-param name="by" select="$rubric//@xpath"/>
      <xsl:with-param name="words" select="$words-list2" />
      <xsl:with-param name="filter-stop-words" select="@use-stopwords" />
   </xsl:call-template>
  </xsl:variable><!-- $content -->

  <xsl:document href="{$directory}/index-{$rubric//@name}.html" omit-xml-declaration="yes" encoding="utf-8">
   <xsl:call-template name="wrapper">
    <xsl:with-param name='content' select='$content' />
   </xsl:call-template>
  </xsl:document>
 </xsl:for-each>

 <xsl:message> Making starting point for navigation : index*.html </xsl:message>
 <!-- =======================================================================-->
 <xsl:variable name='content' >
  <book>
   <xsl:copy-of select="$book-title-URL_doc" />
   <br clear="left"/>

  <!-- Table of family, scientific name, english name: every word appearing in those rubrics are index entries
  <xsl:for-each select="$thesaurus_doc//key/@rubric">
 -->
  <xsl:for-each select="$thesaurus_doc//rubric[@use-keywords!='yes']">
   <xsl:variable name='rubric'>
    <xsl:apply-templates select='.' mode='rubric' />
   </xsl:variable>
   <a href='index-{$rubric//@name}.html' class='index-hyperlink'>
    <xsl:attribute name='title'>Table of
     <xsl:value-of select='$rubric//@label' />
    </xsl:attribute>
    <xsl:value-of select='$rubric//@label' />
   </a>
   <br clear="left" />
  </xsl:for-each>
  <!-- Index by keywords in rubrics -->
  <xsl:for-each select="$thesaurus_doc//rubric[@use-keywords='yes']">
   <xsl:variable name='rubric'>
    <xsl:apply-templates select='.' mode='rubric' />
   </xsl:variable>
   <a href='index-{$rubric//@name}.html' class='index-hyperlink'>
    <xsl:attribute name='title'>Index by
     <xsl:value-of select='$rubric//@label' />
    </xsl:attribute>
    <xsl:value-of select='$rubric//@label' />
   </a>
   <br clear="left" />
  </xsl:for-each>
  </book>
 </xsl:variable>
 <xsl:document href="{$directory}/index.html" omit-xml-declaration="yes" encoding="utf-8">
  <xsl:call-template name="wrapper">
   <xsl:with-param name='content' select='$content' />
  </xsl:call-template>
 </xsl:document>
</xsl:template>

<xsl:template match='*' mode='add-spaces'>
   <xsl:copy-of select="." />
   <xsl:text>
   </xsl:text>
</xsl:template>

<!-- Because :
- the index words will become part of file name, 
- punctuation is not part of the word,
we  suppress unwanted characters; this is applied before making index words list for each rubric. -->
<xsl:template match='text()' mode='suppress-unwanted-chars'>
 <xsl:variable name='search'  >*"[]:,;?()&amp;&#160;</xsl:variable>
 <xsl:variable name='replace' >            </xsl:variable>
 <xsl:value-of select="translate(., $search, $replace )" />
</xsl:template>
</xsl:stylesheet>
