<?xml version="1.0" encoding="ISO-8859-1" ?>
<!--

- punctuation is not part of the word, so we suppress unwanted characters,
- case is irrelevant,
- we don't want to index words beginning with a figure

This is applied before making index words list for each rubric.

Copyright J.M. Vanel 2002 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/

$Header: /usr/local/cvsroot/XMLPublication/kernel/normalize-word.xslt,v 1.1 2002/02/01 14:20:34 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                xmlns:saxon='http://icl.com/saxon'
                exclude-result-prefixes="saxon"
                version="1.0" >

<xsl:template match='*' mode='normalize-word' >
 <xsl:variable name='search'  >*"[]:,;?()&amp;&#160;</xsl:variable>
 <xsl:variable name='replace' >            </xsl:variable>
 <xsl:variable name="majus" select='"ABCDEFGHIJKLMNOPQRSTUVWXYZ"'/>
 <xsl:variable name="minus" select='"abcdefghijklmnopqrstuvwxyz"'/>
 <xsl:variable name="word-minus" select="translate( ., $majus, $minus)" />
 <xsl:variable name="first-char-word-minus" select="substring ($word-minus, 1,1)" />
   <xsl:if test="$word-minus
     and not( $first-char-word-minus='0')
     and not( $first-char-word-minus='1')
     and not( $first-char-word-minus='2')
     and not( $first-char-word-minus='3')
     and not( $first-char-word-minus='4')
     and not( $first-char-word-minus='5')
     and not( $first-char-word-minus='6')
     and not( $first-char-word-minus='7')
     and not( $first-char-word-minus='8')
     and not( $first-char-word-minus='9')
   " > 
     <xsl:variable name="first-pass" select="normalize-space(translate( $word-minus, $search, $replace ))" />
     <xsl:variable name="string-length" select="string-length($first-pass)" />
     <xsl:variable name="last-char" select="substring($first-pass, $string-length)" />
     <xsl:choose>
      <xsl:when test="$last-char='.'">
       <xsl:value-of select="substring($first-pass, 1, $string-length - 1)" />
      </xsl:when>
      <xsl:otherwise>
       <xsl:value-of select="substring($first-pass, 1, $string-length - 1)" />
      </xsl:otherwise>
     </xsl:choose>
   </xsl:if>
</xsl:template>
</xsl:stylesheet>
