<?xml version="1.0"?>
<!-- 
This is an XSLT library, designed to be imported.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /usr/local/cvsroot/XMLPublication/kernel/tokenize-string.xslt,v 1.2 2001/11/09 18:32:40 jmv Exp $ -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:doc="http://xsltsl.org/xsl/documentation/1.0"
	xmlns:str="http://xsltsl.org/string"
	extension-element-prefixes="doc str">

  <xsl:template name="str:tokenize-string">
    <xsl:param name="text"/>
    <xsl:param name="separator" select="' '"/>

    <xsl:choose>
      <xsl:when test="string-length($separator) = 0">
        <xsl:value-of select="$text"/>
      </xsl:when>
      <xsl:when test="contains($text, $separator)">

	<xsl:variable name="before" select="substring-before($text, $separator)"/>
	<xsl:variable name="after" select="substring-after($text, $separator)"/>
          <w>
            <xsl:value-of select="$before"/>
          </w>
        <xsl:call-template name="str:tokenize-string">
	  <xsl:with-param name="text" select="$after"/>
	  <xsl:with-param name="separator" select="$separator"/>
	</xsl:call-template>
      </xsl:when> 
      <xsl:otherwise>
        <w>
          <xsl:value-of select="$text"/>  
        </w>
      </xsl:otherwise>
    </xsl:choose>            
  </xsl:template>

</xsl:stylesheet>
