<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
-->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                xmlns:saxon='http://icl.com/saxon'
                exclude-result-prefixes="saxon"
                version="1.0" >

<xsl:import href='make-words-list.xslt'/>

<xsl:param name='thesaurus'/>
<xsl:variable name='thesaurus_doc' select="document($thesaurus)" />
<xsl:param name='master' select="/" />

<xsl:template match='/'>
 <publication>
 <xsl:for-each select="$thesaurus_doc//@index-by">
  <xsl:variable name='rubric' select="string(.)" />
  <xsl:message>
   Searching words for rubric <xsl:value-of select="string( $rubric )" /> ...
   DEBUG     <xsl:copy-of select="saxon:evaluate(concat('$master//', $rubric ) )" />
  </xsl:message>
  <rubric xpath='{$rubric}'
         item-xpath='absolute_XPath_in_master.xml'
         name='{$rubric}'
         label='human_readable_name'
         use-stopwords='yes'
         use-keywords='yes'
  >
  <keywords rubric='{$rubric}'>
     <xsl:call-template name="make-words-list">
      <xsl:with-param name="string" >
        <xsl:apply-templates select="saxon:evaluate(concat('$master//', $rubric ) )" mode='add-spaces' />
      </xsl:with-param>
     </xsl:call-template>
  </keywords>
  </rubric>
  <xsl:text>
  </xsl:text>
 </xsl:for-each>
 </publication>
</xsl:template>

<xsl:template match='*' mode='add-spaces'>
   <xsl:copy-of select="." />
   <xsl:text>
   </xsl:text>
</xsl:template>

</xsl:stylesheet> 
