<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- Wraps a nodeset fragment of XHTML (or XML) inside an XHTML (or XML) document. An attribute marker is used to tell where to insert the fragment.
This is an XSLT library, designed to be imported.

INPUT:
- nodeset fragment of XHTML: in variable $content 
- XHTML document: from URI in param $presentation; the content is copied inside the element having 
- a class attribute with value 'xmlpub-add-content'
- (deprecated) an non-empty "add-content" attribute

OUTPUT: standard output

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
-->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.0" >

<xsl:param name='HTML-wrapper' select='"./presentation.html"'/>
<xsl:variable name='presentation_doc' select="document($HTML-wrapper)" />

<xsl:template match="*[@add-content] | *[@class = 'xmlpub-add-content']" mode='presentation' priority='100'>
 <xsl:param name='content' />
 <xsl:copy>
  <xsl:copy-of select="@*" />
  <xsl:copy-of select="$content" />
 </xsl:copy>
</xsl:template>

<xsl:template name="wrapper" >
 <xsl:param name='content' />
 <!-- <xsl:processing-instruction name="xml-stylesheet">href="format-HTML.xslt" type="text/xml" </xsl:processing-instruction> -->
 <xsl:apply-templates select="$presentation_doc" mode='presentation' >
  <xsl:with-param name='content' >
   <xsl:copy-of select='$content' />
  </xsl:with-param>
 </xsl:apply-templates>
</xsl:template>

<!-- Pris de M. Kay (xsl:copy) -->
 <xsl:template match="@*|node()|/" mode='presentation' >
   <xsl:param name='content' />

   <xsl:copy>
    <xsl:apply-templates select="@*" mode='presentation'>
     <xsl:with-param name='content' select='$content' />
    </xsl:apply-templates>
    <xsl:apply-templates select="node()" mode='presentation'>
     <xsl:with-param name='content' select='$content' />
    </xsl:apply-templates>
   </xsl:copy>
 </xsl:template>

</xsl:stylesheet> 
