<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xp="http://au.com.Langdale/2000/Xpetal">
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<!-- look up the quidu for each of associations -->
	<xsl:template match="xp:Role|xp:Inheritance_Relationship">
		<xsl:copy>
			<xsl:apply-templates></xsl:apply-templates>
			<xsl:if test="xp:quidu">
				<xsl:for-each select="key('quid',xp:quidu)">
					<xp:referent>
						<xsl:value-of select="xp:arg1"></xsl:value-of>
					</xp:referent>
				</xsl:for-each>
			</xsl:if>
		</xsl:copy>
	</xsl:template>


	<!-- look up the type of attributes -->
	<xsl:template match="xp:ClassAttribute">
		<xsl:copy>
			<xsl:apply-templates></xsl:apply-templates>
			<xsl:if test="xp:type">
				<xsl:for-each select="key('type',xp:type)">
					<xp:stereotype>
						<xsl:value-of select="xp:stereotype"></xsl:value-of>
					</xp:stereotype>
				</xsl:for-each>
			</xsl:if>
		</xsl:copy>
	</xsl:template>
	
	<xsl:key name="quid" match="xp:Class" use="xp:quid"/>
	<xsl:key name="type" match="xp:Class" use="xp:arg1"/>

	<!-- copy thru -->
	<xsl:template match="@*|node()" >
	  <xsl:copy>
	    <xsl:apply-templates select="@*|node()" />
	  </xsl:copy>
	</xsl:template>
</xsl:stylesheet>
