<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xp="http://au.com.Langdale/2000/Xpetal"
>
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<!-- set this to select a class category -->
	<xsl:param name="category">all</xsl:param>
	
	<!-- expecting an Xpetal file -->
	<xsl:template match="xp:Xpetal">
		<xsl:copy>
			<xsl:apply-templates></xsl:apply-templates>
		</xsl:copy>
	</xsl:template>
	
	<!-- suppress default copy of text -->
	<xsl:template match="text()">
	</xsl:template>
	
	<!-- optionally filter categories -->
	<xsl:template match="xp:Class_Category">
		<xsl:if test="$category='all' or xp:arg1=$category">
			<xsl:copy>
				<xsl:apply-templates select="xp:arg1|xp:documentation" mode="copy" ></xsl:apply-templates>
				<xsl:apply-templates></xsl:apply-templates>
			</xsl:copy>
		</xsl:if>
	</xsl:template>
	
	<!-- find classes and associations, the rest is not needed -->
	<xsl:template match="xp:Class|xp:Association">
		<xsl:apply-templates mode="copy" select="."></xsl:apply-templates>
	</xsl:template>
	
	<!-- copy the parts we are interested in -->
	<xsl:template match="@*|node()" mode="copy">
	  <xsl:copy>
	    <xsl:apply-templates select="@*|node()" mode="copy"/>
	  </xsl:copy>
	</xsl:template>
	
	<!-- skip some intervening structure -->
	<xsl:template match="xp:class_attributes" mode="copy">
		<xsl:apply-templates select=".//xp:ClassAttribute" mode="copy"></xsl:apply-templates>
	</xsl:template>
	<xsl:template match="xp:superclasses" mode="copy">
		<xsl:apply-templates select=".//xp:Inheritance_Relationship" mode="copy"></xsl:apply-templates>
	</xsl:template>
	<xsl:template match="xp:roles" mode="copy">
		<xsl:apply-templates select=".//xp:Role" mode="copy"></xsl:apply-templates>
	</xsl:template>

	<!-- skip tool attributes except for cim -->
	<xsl:template match="xp:attributes" mode="copy">
		<xsl:apply-templates select=".//xp:Attribute[xp:tool='Cim']" mode="copy"></xsl:apply-templates>
	</xsl:template>
</xsl:stylesheet>
