<?xml version="1.0" encoding="UTF-8"?>
<!-- edited with XML Spy v3.0.7 NT (http://www.xmlspy.com) by Arnold deVos (Langdale Consultants) -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:cims="http://iec.ch/TC57/1999/rdf-schema-extensions-19990926#" >
        <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
        <xsl:param name="pname"></xsl:param>
        <xsl:template match="rdfs:Class">
			<xsl:variable name="ref">
				<xsl:choose>
					<xsl:when test="@rdf:ID"><xsl:value-of select="concat('#',@rdf:ID)"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="@rdf:about"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="id" select="substring-after($ref,'#')"/>
               <div>
                        <h1>
                                <xsl:attribute name="id"><xsl:value-of select="$id"/></xsl:attribute>
                                <xsl:if test="$pname != '' and cims:profile=$pname">
                                    <xsl:attribute name="class">Highlight</xsl:attribute>
                                </xsl:if>
                                <xsl:value-of select="$id"/>
                        </h1>
                        <div>
                                <h2>Category</h2>
                                <p class="label">
                                        <xsl:value-of select="cims:belongsToCategory/@rdf:resource"/>
                                </p>
                        </div>
                        <div>
                                <h2>Description</h2>
                                <p class="label">
                                        <xsl:value-of select="rdfs:label"/>
                                        <xsl:text>:</xsl:text>
                                </p>
                                <p class="comment">
                                        <xsl:value-of select="rdfs:comment"/>
                                </p>
                        </div>
                        <div>
                                <h2>Inherits</h2>
                                <xsl:apply-templates select="rdfs:subClassOf"/>
                        </div>
                        <div>
                                <h2>Inherited By</h2>
                                <xsl:apply-templates select="/rdf:RDF/rdfs:Class[rdfs:subClassOf/@rdf:resource=$ref]" mode="reference">
                                        <xsl:sort select="rdfs:label"/>
                                </xsl:apply-templates>
                        </div>
                        <div>
                                <h2>Properties</h2>
                                <dl>
                                        <xsl:apply-templates select="/rdf:RDF/rdf:Property[rdfs:domain/@rdf:resource=$ref]">
                                                <xsl:sort select="rdfs:label"/>
                                        </xsl:apply-templates>
                                </dl>
                        </div>
                        <div>
                                <h2>Values</h2>
                                <dl>
                                        <xsl:apply-templates select="/rdf:RDF/rdf:Description[rdf:type/@rdf:resource=$ref]">
                                                <xsl:sort select="rdfs:label"/>
                                        </xsl:apply-templates>
                                </dl>
                        </div>
                </div>
        </xsl:template>
        <xsl:template match="rdf:Description">
			<xsl:variable name="ref">
				<xsl:choose>
					<xsl:when test="@rdf:ID"><xsl:value-of select="concat('#',@rdf:ID)"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="@rdf:about"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="id" select="substring-after($ref,'#')"/>
                <dt>
                        <xsl:if test="$pname != '' and cims:profile=$pname">
                            <xsl:attribute name="class">Highlight</xsl:attribute>
                        </xsl:if>
                        <xsl:value-of select="$id"/>
                </dt>
                <dd>
                        <p class="comment">
                                <xsl:value-of select="rdfs:comment"/>
                        </p>
                </dd>
        </xsl:template>
        <xsl:template match="rdf:Property">
			<xsl:variable name="ref">
				<xsl:choose>
					<xsl:when test="@rdf:ID"><xsl:value-of select="concat('#',@rdf:ID)"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="@rdf:about"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="id" select="substring-after($ref,'#')"/>
                <dt>
                        <xsl:if test="$pname != '' and cims:profile=$pname">
                            <xsl:attribute name="class">Highlight</xsl:attribute>
                        </xsl:if>
                        <xsl:value-of select="$id"/>
                </dt>
                <dd>
                        <xsl:variable name="range" select="substring-after(rdfs:range/@rdf:resource,'#')"/>
                        <xsl:if test="$range!=''">
                                <p>
                                        <a>
                                                <xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:value-of select="$range"/></xsl:attribute>
                                                <xsl:value-of select="$range"/>
                                        </a>
                                </p>
                        </xsl:if>
                        <xsl:variable name="type" select="substring-after(cims:dataType/@rdf:resource,'#')"/>
                        <xsl:if test="$type!=''">
                                <p>
                                        <a>
                                                <xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:value-of select="$type"/></xsl:attribute>
                                                <xsl:value-of select="$type"/>
                                        </a>
                                </p>
                        </xsl:if>
                        <p class="comment">
                                <xsl:value-of select="rdfs:comment"/>
                        </p>
                </dd>
        </xsl:template>
        <xsl:template match="rdfs:subClassOf">
                <p>
                        <a>
						  <xsl:variable name="base" select="substring-after(@rdf:resource,'#')"/>
                                <xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:value-of select="$base"/></xsl:attribute>
                                <xsl:value-of select="$base"/>
                        </a>
                </p>
        </xsl:template>
        <xsl:template match="rdfs:Class" mode="reference">
			<xsl:variable name="ref">
				<xsl:choose>
					<xsl:when test="@rdf:ID"><xsl:value-of select="concat('#',@rdf:ID)"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="@rdf:about"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="id" select="substring-after($ref,'#')"/>
			<xsl:if test="$id">
	                <p>
	                        <a>
	                                <xsl:attribute name="href"><xsl:text>#</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
	                                <xsl:value-of select="$id"/>
	                        </a>
	                </p>
			</xsl:if>
        </xsl:template>
        <xsl:template match="rdf:RDF">
                <html>
                        <head>
                                <title>RDF Schema Listing</title>
                                <style type="text/css">
                                    H1 {
                                            FONT-FAMILY: sans-serif
                                    }
                                    H1.Highlight { background-color: yellow }
                                    H2 {
                                            FONT-FAMILY: sans-serif
                                    }
                                    H3 {
                                            FONT-FAMILY: sans-serif
                                    }
                                    H1 {
                                            BORDER-BOTTOM-STYLE: double; COLOR: rgb(0,58,69); PADDING-BOTTOM: 10px
                                    }

                                    body { margin-left: 10%; margin-right: 10%; }
                                    h1 { margin-left: -8%;}
                                    h2,h3,h4,h5,h6 { margin-left: -4%; }
                                    dt {font-size: medium }
                                    dt.Highlight { background-color: yellow }
                                    p.label {font-size: medium }
                                    P.menu {
                                            FONT-FAMILY: sans-serif; FONT-SIZE: x-small; MARGIN: 0.5em
                                    }
                                    LI {
                                            MARGIN-TOP: 1.5em
                                    }
                                    BODY {
                                            BACKGROUND-COLOR: rgb(254,239,223);
                                            FONT-FAMILY: sans-serif;
                                    }
                                    spare {
                                            BACKGROUND-COLOR: rgb(186,188,170)
                                    }

                                    .toc	{ FONT-SIZE: smaller }
                                </style>
                        </head>
                        <body>
                                <xsl:apply-templates select="rdfs:Class">
                                        <xsl:sort select="rdfs:label"/>
                                </xsl:apply-templates>
                        </body>
                </html>
        </xsl:template>
</xsl:stylesheet>
