<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
This is an XSLT library, designed to be imported.
Header and files names generation are delegated to the  
templates item_name, item_file_name_html in imported XSLT library item_file_name.xslt.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /home/jmv/cvsroot/XMLPublication/kernel/make-hyperlinked-index.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                xmlns:saxon='http://icl.com/saxon'
                exclude-result-prefixes="saxon"
                version="1.0" >

<xsl:import href="item_file_name-generic.xslt" />

<!-- Parameters: 
Output: XHTML markup containing <a href=''> elements
Input:
of: an XPath match, relative to the root, indicating which items to index
by: an XPath location, relative to an item, indicating which rubric to search for indexing content
 -->
<xsl:template name="make-hyperlinked-index">
 <xsl:param name="of" />
 <xsl:param name="by" />
 <xsl:param name="words" />
 <xsl:param name="source" />
 <xsl:param name="filter-stop-words" select="'yes'"/>

 <xsl:message>[XMLPub] Making hyperlinked index of items at xpath=<xsl:value-of select="$of" /> by values of relative xpath=<xsl:value-of select="$by" /> (<xsl:copy-of select="count($words//w)" /> entries) ...</xsl:message>
 <xsl:variable name="apos" >"</xsl:variable>

 <h2> Keywords </h2>
 <xsl:for-each select="$words//w" >
  <xsl:variable name="word" select='.'/>
  <xsl:if test="not ( $filter-stop-words = 'yes' and
                      $word/@is-stop-word )" >
  <xsl:variable name="first-char-word-minus" select="substring ( ., 1,1)" />
  <xsl:if test=" .
     and not( $first-char-word-minus='0')
     and not( $first-char-word-minus='1')
     and not( $first-char-word-minus='2')
     and not( $first-char-word-minus='3')
     and not( $first-char-word-minus='4')
     and not( $first-char-word-minus='5')
     and not( $first-char-word-minus='6')
     and not( $first-char-word-minus='7')
     and not( $first-char-word-minus='8')
     and not( $first-char-word-minus='9')
   " >
   <a href='#{.}' class='word-hyperlink'> <xsl:copy-of select="." /> </a> , 
  </xsl:if>
  </xsl:if>
 </xsl:for-each>

 <h2> Items </h2><!-- (grouped by keyword value) -->

 <xsl:variable name="majus" select='"ABCDEFGHIJKLMNOPQRSTUVWXYZ"'/>
 <xsl:variable name="minus" select='"abcdefghijklmnopqrstuvwxyz"'/>
 <xsl:for-each select="$words//w" >
  <xsl:variable name="word" select='.'/>
  <xsl:if test="not ( $filter-stop-words = 'yes' and
                      $word/@is-stop-word )" >

   <xsl:variable name="word-minus" select="translate($word,$majus,$minus)" />
   <xsl:variable name="first-char-word-minus" select="substring ($word-minus, 1,1)" />
   <xsl:if test="$word-minus
     and not( $first-char-word-minus='0')
     and not( $first-char-word-minus='1')
     and not( $first-char-word-minus='2')
     and not( $first-char-word-minus='3')
     and not( $first-char-word-minus='4')
     and not( $first-char-word-minus='5')
     and not( $first-char-word-minus='6')
     and not( $first-char-word-minus='7')
     and not( $first-char-word-minus='8')
     and not( $first-char-word-minus='9')
   " >
  <div>
   <a name='{$word}'/><h3 class='word-hyperlinks-list' > <xsl:copy-of select="$word" /> : </h3>

   <!-- query all items ($of) whose rubric $by contains $word-minus -->
   <xsl:variable name="query" select="concat('$source/*/',$of,'[',$by,'[contains( translate(.,$majus,$minus),',$apos, $word-minus ,$apos,')]]')" />
   <xsl:variable name="matches" select="saxon:evaluate($query)" />

   <!-- <xsl:message> DEBUG make-hyperlinked-index: query: <xsl:value-of select="$query" /> </xsl:message> -->
   <xsl:message>[XMLPub] match count for word "<xsl:value-of select="$word" />" : <xsl:value-of select="count($matches)" /> </xsl:message>
   <!-- <xsl:message> DEBUG make-hyperlinked-index: $matches: {<xsl:value-of select="$matches" />} </xsl:message> -->
    <xsl:for-each select="$matches" >
    <div>
     <xsl:variable name="HREF">
      <xsl:call-template name="item_file_name_html" />
     </xsl:variable>
     <a href='{$HREF}' class='item-hyperlink'>   
      <xsl:call-template name="item_name" />,
     </a>
    </div>
   </xsl:for-each>
  </div>
  </xsl:if>
  </xsl:if>

 </xsl:for-each>
 
</xsl:template>
</xsl:stylesheet>
