<?xml version="1.0" encoding="ISO-8859-1" ?>
<!-- 
Purpose: tokenize, suppress doubles and sort a string
This is an XSLT library, designed to be imported.

Copyright J.M. Vanel 2001 - under GNU public licence 
jmvanel@free.fr 

Worldwide Botanical Knowledge Base 
http://wwbota.free.fr/
$Header: /home/jmv/cvsroot/XMLPublication/kernel/make-words-list.xslt,v 1.1.1.1 2002/05/08 07:56:07 jmv Exp $ -->

<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
                version="1.1"
 	xmlns:doc="http://xsltsl.org/xsl/documentation/1.0"
	xmlns:str="http://xsltsl.org/string"
	extension-element-prefixes="doc str">

  <xsl:import href="unique.xslt" />
  <xsl:include href="tokenize-string.xslt" />

<!-- 
Purpose: tokenize, suppress doubles and sort a string
Parameters:
Input:
- string: a whitespace-separated string
Output: a node list containing <w> elements, with 1 element per word occuring in $string . 
xslsl: conformance: $string doit s'appeler $text
-->
  <xsl:template name="make-words-list">
    <xsl:param name="string" />

    <xsl:message> saxon:tokenize string of length <xsl:value-of select="string-length ($string)" /> </xsl:message>
    <xsl:variable name="words-with-repetitions" select="saxon:tokenize($string)" xmlns:saxon="http://icl.com/saxon"/>
    <xsl:message> saxon:tokenize , token count: <xsl:value-of select="count ($words-with-repetitions)" /> </xsl:message>

    <xsl:variable name="unsorted-words-list">
    <!-- ZZZZZZZZZZZZZZZZ call make-unique -->
    <xsl:for-each select="$words-with-repetitions" >
      <xsl:variable name="before" select="preceding-sibling::* "/>
      <xsl:variable name="first-appearance" select="not(string(.) = $before)"/>
      <xsl:if test="$first-appearance" >
        <xsl:copy-of select="."/>
      </xsl:if>
    </xsl:for-each>
    </xsl:variable>
    <xsl:for-each select="$unsorted-words-list/*" >
     <xsl:sort /><w><xsl:value-of select="." /></w>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet> 
